# Stub for ALICE. Expects the ALICE agent to be started in a separate process.
# Filters some responses and manipulates scores.

require 'drb'

class ALICEAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @alice = DRbObject.new(nil, 'druby://localhost:9020')
  end

  def method_missing(input = "")
    input = input.to_s
    input.chomp!
    response = ''
    #score = rand(3) + 1
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^alice/ then return end
    if input =~ /^restart (.*)/ then return end
    if input =~ /^link\b/ then return end
    if input =~ /^lgp\b/ then return end
    if input =~ /^calc\b/ then return end
    if input =~ /^porsi\b/ then return end
    if input =~ /(morning|evening|afternoon)+/ then return end # otherwise alice crashes!
    if input =~ /^what is your name\?/i 
      @callerObj.addResponse ["alice", 1, "alice"] 
      return
    end
    response, score = @alice.getResponse(input.to_s) unless input =~ /\#/
    if score == nil then score = 4 end
    if response == nil then score = 0 end
    if response.strip == '' then score = 0 end
    # Filter out repeated responses.
    ar = response.split
    startwords = ar[0,4].join(" ")
    #puts "[alice] startwords==#{startwords}; response==#{response}"
    if response =~ /(#{startwords}.*)(#{startwords}.*)/
      response = $1.to_s
    end
    puts "ALICE: #{response} | #{score}"  unless @callerObj.DEBUG == 0
    #@callerObj.addResponse([response, score])
    @callerObj.addResponse([response, score, "alice"])
  end

end
