require 'test/unit'
require 'bcagent'

class TestMyAgent < Test::Unit::TestCase

  def setup
    @agent = MyAgent.new
  end

  def test_if_p_then_q
    actual, s = @agent.send("if a -> b and b, then c")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("if x -> y and y -> z, then x -> z")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("is 'c' true?")
    assert_match(/true/, actual)

    actual, s = @agent.send("is x -> z true?")
    assert_match(/and.*true/, actual)

    actual, s = @agent.send("if p -> q then x -> z")
    puts "actual==#{actual}"
    assert_match(/Okay/, actual)

    actual, s = @agent.send(" is 'x -> z' true?")
    assert_match(/or.*true/, actual)

    actual, s = @agent.send("show all the if p then q rules, please")
    assert_match(/a -> b.*x -> z/m, actual)

    actual, s = @agent.send('delete "if x -> y and y -> z, then x -> z"')
    assert_match(/Okay/, actual)

    actual, s = @agent.send("show if p then q rules")
    assert_match(/\Aif a -> b and b, then c\Z/, actual)

    actual, s = @agent.send("delete all the if p then q rules")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("show if p then q rules")
    assert_match('', actual)
  end

end
