require 'test/unit'
require 'bcbot'

class TestMyBot < Test::Unit::TestCase

  def setup
    @agent = MyBot.new
  end

  def test_name
    actual, s = @agent.send("what is your name?")
    assert_match(/bcbot/, actual)
  end

  def test_volume
    actual, s = @agent.send("bcbot: what is your volume?")
    assert_match(/1/, actual)
  end

  def test_rules
    actual, s = @agent.send("bcbot: loud")
    assert_match(/0/, actual)

    actual, s = @agent.send("bcbot: if response =~ /default response/i then response = 'foo!' end")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("testing")
    assert_match(/foo!/, actual)

    actual, s = @agent.send("bcbot: if response =~ /foo!/ then response = 'bar' end")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("testing")
    assert_match(/bar/, actual)

    actual, s = @agent.send("bcbot: delete rule 1")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("testing")
    assert_match(/default response/i, actual)

    actual, s = @agent.send("bcbot: if response =~ /default response/i then response = 'fubar' end")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("testing")
    assert_match(/fubar/, actual)

    actual, s = @agent.send("bcbot: delete all rules")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("bcbot: show rules")
    assert_match(//, actual)

    actual, s = @agent.send("testing")
    assert_match(/Default response/, actual)
  end

  def test_if_p_then_q_rules
    actual, s = @agent.send("if A recommends silver then C buys silver")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("bcagent: show the if p then q rules, please")
    assert_match(/then C buys silver/, actual)
  end

end
