require 'drb'

class BCAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @agent = DRbObject.new(nil, 'druby://localhost:9100')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(agent|bot)/i and input !~ /^bc|back/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^porsi\b/i then return end
    response, score = @agent.getResponse(input)
    if score == nil then score = 1 end
    if response =~ /Default response/ then score = 0 end
    if response =~ /because/ then score += 1 end
    if response =~ /Yes/ then score += 1 end
    if response =~ /Okay/ then score -= 2 end
    if input =~ /(?:bcagent|bcbot|bcagentbot|backchainer|backchainagent)/i
      score += 4 
    end
    if response == nil or response.strip == '' then score -= 2 end
    puts "BCAgent: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "bcagent"])
  end
end
