# Submits input asynchronously to agents, then loops through their responses 
# until it finds a high scoring response, or until a time limit is reached. 

# The alternate require paths are relative to the redturnip root directory.
begin require 'gagent'; rescue LoadError; require 'mod/bot/gagent'; end
begin require 'aliceagent'; rescue LoadError; require 'mod/bot/aliceagent'; end
#begin require 'mathetesagent'; rescue LoadError; require 'mod/bot/mathetesagent'; end
begin require 'wnagent'; rescue LoadError; require 'mod/bot/wnagent'; end
begin require 'linkagent'; rescue LoadError; require 'mod/bot/linkagent'; end
begin require 'megahalagent'; rescue LoadError; require 'mod/bot/megahalagent'; end
begin require 'montyagent'; rescue LoadError; require 'mod/bot/montyagent'; end
begin require 'isragent'; rescue LoadError; require 'mod/bot/isragent'; end
begin require 'lingagent'; rescue LoadError; require 'mod/bot/lingagent'; end
begin require 'bcagent'; rescue LoadError; require 'mod/bot/bcagent'; end
begin require 'sumagent'; rescue LoadError; require 'mod/bot/sumagent'; end
begin require 'emoagent'; rescue LoadError; require 'mod/bot/emoagent'; end
begin require 'oppagent'; rescue LoadError; require 'mod/bot/oppagent'; end
begin require 'logicwrapper'; rescue LoadError; require 'mod/bot/logicwrapper'; end
begin require 'ifwrapper'; rescue LoadError; require 'mod/bot/ifwrapper'; end
begin require 'testwrapper'; rescue LoadError; require 'mod/bot/testwrapper'; end
begin require 'restartwrapper'; rescue LoadError; require 'mod/bot/restartwrapper'; end
begin require 'lppagent'; rescue LoadError; require 'mod/bot/lppagent'; end
begin require 'dpagentwrapper'; rescue LoadError; require 'mod/bot/dpagentwrapper'; end
begin require 'todoagentwrapper'; rescue LoadError; require 'mod/bot/todoagentwrapper'; end
begin require 'syllagentwrapper'; rescue LoadError; require 'mod/bot/syllagentwrapper'; end
begin require 'calcagentwrapper'; rescue LoadError; require 'mod/bot/calcagentwrapper'; end
begin require 'porsiagentwrapper'; rescue LoadError; require 'mod/bot/porsiagentwrapper'; end
begin require 'translateagentwrapper'; rescue LoadError; require 'mod/bot/translateagentwrapper'; end
begin require 'chordagentwrapper'; rescue LoadError; require 'mod/bot/chordagentwrapper'; end
begin require 'faqagentwrapper'; rescue LoadError; require 'mod/bot/faqagentwrapper'; end
begin require 'wikiagentwrapper'; rescue LoadError; require 'mod/bot/wikiagentwrapper'; end
begin require 'googleagentwrapper'; rescue LoadError; require 'mod/bot/googleagentwrapper'; end
begin require 'akagentwrapper'; rescue LoadError; require 'mod/bot/akagentwrapper'; end
begin require 'becauseagentwrapper'; rescue LoadError; require 'mod/bot/becauseagentwrapper'; end
begin require 'bartagentwrapper'; rescue LoadError; require 'mod/bot/bartagentwrapper'; end
begin require 'analectsagentwrapper'; rescue LoadError; require 'mod/bot/analectsagentwrapper'; end
begin require 'waagentwrapper'; rescue LoadError; require 'mod/bot/waagentwrapper'; end

BasicSocket.do_not_reverse_lookup = true # To make DRb.start_service faster

class Controller

  attr_accessor :MY_NAME, :DEBUG, :DELAY, :SLEEP

  def initialize(creator = Object.new)
    @creator = creator
    @gagent = GAgent.new(self) # port 9011
    @logic = LogicAgentWrapper.new(self) # port 9012
    @alice = ALICEAgent.new(self) # port 9020
    #@mathetes = MathetesAgent.new(self) # port 9030
    @wnbot = WNAgent.new(self) # port 9040
    @link = LinkAgent.new(self) # port 9050
    @megahal = MegaHALAgent.new(self) # port 9060
    @monty = MontyAgent.new(self) # port 9070
    @isr = ISRAgent.new(self) # port 9080
    @ling = LingAgent.new(self) # port 9090
    @bc = BCAgent.new(self) # port 9100
    @sum = SumAgent.new(self) # port 9110
    @opp = OppAgent.new(self) # port 9120
    @emo = EmoAgent.new(self) # port 9130
    @if = IfAgentWrapper.new(self) # port 9131
    @test = TestAgentWrapper.new(self) # port 9140
    @restart = RestartAgentWrapper.new(self) # port 9150
    @lpp = LppAgent.new(self)
    @dp = DPAgentWrapper.new(self) # port 9160
    @todo = TodoAgentWrapper.new(self) # port 9170
    @syll = SyllAgentWrapper.new(self) # port 9180
    @calc = CalcAgentWrapper.new(self) # port 9190
    @porsi = PorsiAgentWrapper.new(self) # port 9200
    @translate = TranslateAgentWrapper.new(self) # port 9210
    @chord = ChordAgentWrapper.new(self) # port 9220
    @faq = FAQAgentWrapper.new(self) # port 9230
    @wiki = WikiAgentWrapper.new(self) # port 9240
    @google = GoogleAgentWrapper.new(self) # port 9250
    @ak = AkAgentWrapper.new(self) # port 9260
    @because = BecauseAgentWrapper.new(self) # port 9270
    @bart = BartAgentWrapper.new(self) # port 9280
    @an = AnalectsAgentWrapper.new(self) # port 9290
    @wa = WAAgentWrapper.new(self) # port 9300
    @agent_array = [ @gagent, @alice, @wnbot, @link, #@mathetes,
                     @megahal, @monty, @isr, @ling, @bc, @sum,
                     @emo, @opp, @if, @logic, @test, @restart,
                     @lpp, @dp, @todo, #@syll, 
                     @calc, @porsi, @translate, @chord, @faq,
                     @wiki, @google, @ak, @because, @bart, @an, @wa ]
    @response_array = Array.new
    @THRESHOLD = 1
    @SLEEP = 2 # how long the poll loop sleeps each time through 
    @DELAY = 5 # maximum seconds to wait before returning a response
    @MY_NAME = "(?i)(controller|controlbot|controlagent)"
    @DEBUG = 0
    @last_response = Array.new
    @negative_feedback = Array.new
    @negative_feedback.push("you suck", "that response suck")
    @positive_feedback = Array.new
    @positive_feedback.push("good one")
    @positive_feedback.push("lol")
    @positive_feedback.push("haha")

    puts "\nReading remember.txt..."
    read_file("remember.txt") # load "remember: ___" commands
    @pending_response = Array.new
    @wait_for_agents = Array.new
    puts "\nHello"
  end

  def check_for_preprocessing_commands(input)
    case input

    when /what agents .* loaded/, /show .*agents/i, /list .*agents/i
      @response_array = Array.new
      puts "    beginning of 'list agents' block"
      count = 0
      @agent_array.each { |agent|
        count += 1
        puts "       loop #{count}"
        Thread.new(agent) { |myagent|
          myagent.send("what is your name?")
        }
        sleep(@SLEEP.to_f)
      }
      responses = Array.new; @response_array.each { |response| responses.push(response[2]) } 
      @response_array = Array.new
      @last_response = ["agent names", 1, "controlbot"]
      return responses.join(", ")

    when /add (.*) (?:to|as) negative feedback(.*)/i
      grp1 = process $1; grp2 = process $2
      save = true
      puts "[controller].check_for_preprocessing_commands: grp2==#{grp2}"
      if grp2 =~ /.*do.*n.*t.*save/ then save = false end
      puts "[controller] save==#{save}"
      @negative_feedback.push(grp1)
      # add to this file
      if save
        file = IO.read(__FILE__)
        #puts "file==#{file}"
        case file
        when /(.*?)(@negative_feedback.push\(.*?\))(.*)/m
          g1 = $1; g2 = $2; g3 = $3
          newfile = g1 + g2 + "\n    @negative_feedback.push(\"#{grp1}\")" + g3
          # Writing to file disabled for testing!
          #File.open("controller.rb", "w+") { |f|
          #  f.puts newfile
          #}
        end # case
      end # if
      return "Okay"

    when /delete (.*) from negative feedback/i
      grp1 = process $1
      @negative_feedback.delete(grp1)
      # TODO: delete from this file
      return "Okay"

    when /show negative feedback/i
      return @negative_feedback.join('|')

    when /^#{@negative_feedback.join('|')}/i
      # write to log
      File.open("feedback.txt", "a+") { |f|
        s = Regexp.escape(@last_response[0].strip)
        f.puts "#{@last_response[2]}: if response =~ /#{s}/ then score -= 1 end"
      }
      return getResponse("#{@last_response[2]}: if response =~ /#{@last_response[0].strip}/ then score -= 1 end")

    when /add (.*) (?:to|as) positive feedback(.*)/i, /positive feedback: (.*)/
      grp1 = process $1; grp2 = process $2
      save = true
      if grp2 =~ /.*do.*n.*t.*save/ then save = false end
      @positive_feedback.push(grp1)
      # add to this file
      if save
        file = IO.read(__FILE__)
        #puts "file==#{file}"
        case file
        when /(.*?)(@positive_feedback.push\(.*?\))(.*)/m
          g1 = $1; g2 = $2; g3 = $3
          newfile = g1 + g2 + "\n    @positive_feedback.push(\"#{grp1}\")" + g3
          # Writing to file disabled for testing!
          #File.open("controller.rb", "w+") { |f|
          #  f.puts newfile
          #}
        end # case
      end # if
      return "Okay"

    when /delete (.*) from positive feedback/i
      grp1 = process $1
      @positive_feedback.delete(grp1)
      # TODO: delete from this file
      return "Okay"

    when /^(#{@positive_feedback.join('|')})$/i
      # write to log
      File.open("feedback.txt", "a+") { |f|
        f.puts "#{@last_response[2]}: if response =~ /#{@last_response[0].strip}/ then score += 1 end"
      }
      #return getResponse("#{@last_response[2]}: if response =~ /#{@last_response[0].strip}/ then score += 1 end")

    when /show positive feedback/i, /show.*positive.*feedback/i
      return @positive_feedback.join('|')

    when /read feedback file/i, /read.*feedback.*file/i, /read.*feedback/i
      return read_feedback_file

    when /who said that/i, /wh.*agent.*that/i, /wh.*said.*it/i
      return @last_response[2].to_s << " said " << @last_response[0].to_s

    when /what was the score/i#, /wh.*score/i
      return @last_response[1].to_s

    when /remember that (.*)/i, /remember (.*)/i, /remember: (.*)/i
      grp1 = $1.to_s
      File.open("remember.txt", "a+") { |f|
        f.puts(grp1)
      }
      return getResponse(grp1)

    end # case

  end # check_for_preprocessing_commands

  def read_feedback_file
    read_file("feedback.txt")
  end

  # TODO: make sure directory is correct
  def read_file(file = 'feedback.txt')
    count = 0
    begin
      IO.foreach(file) { |statement|
        if statement =~ /^#/ then next end
        if statement.strip == '' then next end
        count += 1
        puts "#{count}: #{statement}"
        response = getResponse(statement)
        if response == nil then response = "No response!" end
        puts response unless @DEBUG == 0
      } 
    rescue Exception => boom 
      puts boom
      return boom 
    end
    s = 's'; if count == 1 then s = '' end
    return "Okay, #{file} read: #{count} statement#{s}." 
  end

  # Strips delimiters.
  def process str
    if str.class != String then return '' end
    str.strip!
    str.sub!(/\?$/, '')
    str.sub!(/^\[/, '')
    str.sub!(/\]$/, '')
    str.sub!(/^(?:"|')/, '')
    str.sub!(/(?:"|')$/, '')
    str.sub!(/\.$/, '')
    str.sub!(/;$/, '')
    str.sub!(/,$/, '')
    str.sub!(/!$/, '')
    str.sub!(/\?$/, '')
    return str 
  end

  def check_for_pending_response
    puts "     @last_response   =#{@last_response}." unless @DEBUG == 0
    puts "     @pending_response=#{@pending_response}." unless @DEBUG == 0
    if @last_response.eql?(@pending_response) 
      @pending_response = Array.new; return nil 
    end
    toReturn = @pending_response; @pending_response = Array.new; return toReturn
  end

  def setResponse(response = '', score = 1)
    puts "[controller.setResponse] setting response to: #{response}" unless @DEBUG == 0
    #puts @creator.public_methods
    begin 
      @creator.setResponse(response, score) 
    rescue Exception => e 
      puts e 
      #begin; @creator.display(response); rescue Exception => e2; puts e2; end
    end
     
    #puts response
    @responded = true
  end

  def getResponse(input = "")
    puts "[controller.getResponse 1] @responded == #{@responded}."
   begin
    r = check_for_preprocessing_commands(input)
    if r != nil and !r.empty? then return r end
    r = check_for_pending_response
    if r != nil and !r.empty? then return r end
    @response_array = []
    submitInput(input)
    total_seconds = 0
    some_response = ["Default response from controller.", 0, "controller"]
    max_so_far = 0 
    # Every few seconds, loop through @response_array looking for 
    # high-scoring responses.
    loop {     
      sleep(@SLEEP.to_f) 
      @response_array.each { |response|
        #puts "response==#{response}"
        score = response[1] rescue score = 1
        if input =~ /#{@MY_NAME}[:,!]* (.*)/ then score += 2 end
        response[1] = score
        if score > max_so_far
          some_response = response
          max_so_far = score
        end
      }
 
      puts "[controller.getResponse 2] @responded == #{@responded}."
      #if @responded then @responded = false; return; end

      total_seconds += @SLEEP.to_f
      if total_seconds > @DELAY.to_f
        @last_response = some_response
        #puts "2. @last_response==#{@last_response}"
        return some_response unless not @wait_for_agents == nil and @wait_for_agents.empty?
      end
      if total_seconds > 3 * @DELAY.to_f then unset_wait_for_agent('all'); return some_response end
    }
   rescue; ensure; @responded = false; end
  end

  # Send input asynchronously to agents.
  def submitInput(input)
    if input =~ /#{@MY_NAME}[:,!]* (.*)/ then input = $1 end
    @agent_array.each { |agent|
      Thread.new(agent) { |myagent|
        myagent.send(input)
      }
      # if input =~ an agent name, send it to that agent only
    #  begin
    #    if input =~ /#{agent.MY_NAME}[:,!]* / then break end
    #  rescue
    #    puts "error!"
    #  end
    }
  end

  # Callback for agents.
  def addResponse(response)
    if response.size == 2 then response.push("unknown") end
    #puts "addResponse called with: #{response}"
    @response_array.push(response)
  end

  # Callback to populate @pending_response.
  def addPendingResponse(response)
    puts "addResponse called with: #{response}" unless @DEBUG == 0
    @pending_response = response
  end

  # Callback
  def set_wait_for_agent(agent)
    @wait_for_agents.push(agent) unless @wait_for_agents.include?(agent)
    puts "@wait_for_agents set to  : #{@wait_for_agents.inspect}" unless @DEBUG == 0
  end

  # Callback
  def unset_wait_for_agent(agent='')
    if agent == '' or agent =~ /all/i then @wait_for_agents.clear end 
    @wait_for_agents.delete(agent)
    puts "@wait_for_agents unset to: #{@wait_for_agents.inspect}" unless @DEBUG == 0
  end

end

if $0 == __FILE__
  c = Controller.new
  print "\n> "; $stdout.flush
  quitwords = [":q", "quit", "exit", "bye"]
  while (line = gets) !~ /^#{quitwords.join('|')}$/ and line !~ /^$/
    response = c.getResponse(line.to_s).to_s + "\n\n"
    print "\n#{response}"
    print "> "; $stdout.flush
  end
  puts "Bye"
end
