require 'test/unit'
require 'createagent'
require 'fileutils'

class TestMyAgent < Test::Unit::TestCase

  def setup
    if File.exist?('createagent.rb')
      FileUtils.copy('createagent.rb', 'createagent.rb.save')
      begin 
        FileUtils.copy('createagent-api.yaml', 'createagent-api.yaml.save') 
      rescue; end
    end
    @agent = MyAgent.new
  end 

  def test_defining_hello
    actual, s = @agent.send("add pattern /^hello/, hello")
    
    actual, s = @agent.send("hello")

    actual, s = @agent.send(">  def hello(pattern=nil, input=nil)")
    actual, s = @agent.send(">    if @count == nil; @count = 1; return 'I am ready for my first lesson.'; end")
    actual, s = @agent.send(">    return 'Hello again.'")
    actual, s = @agent.send(">  end # method_def")

    actual, s = @agent.send("hello")
    assert_match(/lesson/, actual)

    actual, s = @agent.send("hi is a synonym for hello")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("hi")
    assert_match(/again/, actual)
  end

  def teardown
    File.delete('createagent.rb') unless !File.exist?('createagent.rb.save')
    begin; File.delete('createagent-api.yaml'); rescue; end
    if File.exist?('createagent.rb.save')
      FileUtils.copy('createagent.rb.save', 'createagent.rb')
      begin; FileUtils.copy('createagent-api.yaml.save', 'createagent-api.yaml'); rescue; end
    end
    if File.exist?('createagent.rb') then File.delete('createagent.rb.save') end
    if File.exist?('createagent-api.yaml.save') then File.delete('createagent-api.yaml.save') end
  end

end
