# Constructs a test program from a dialog of the form:
#
#      > input
#      bot's response
#
# The bot's response is the expected result.
# 
# To make a test dialog, use gagent's "start log" and "end log" commands.
# Then: 
#   C:> ruby d2t.rb log.txt
#   test_log.rb written.
# Now you can run the generated test:
#   C:> ruby test_log.rb

class D2t

  def initialize
    if $*.empty?
      puts "Usage: #{__FILE__} dialog1"
      exit
    end
    start_testString
    $*.each { |f|
      if f =~ /(.*)\..*/
        @name = $1
      end
      @testFile = "test_" << @name << ".rb"
      process f
    }
    end_testString
    File.open(@testFile, "w") { |f|
      f.puts(@testString)
    }
    puts "#{@testFile} written."
  end

  def start_testString
    @testString = %q(
require 'test/unit'
require 'gagent'

class TestFile < Test::Unit::TestCase

  def setup
    @agent = MyAgent.new
    @agent.send("reset graph")
    @agent.send("set save mode off")
  end

  def test_1
)
  end

  def end_testString
    @testString << "  end\n\n"
    @testString << "end #class"
    #puts @testString
  end

  def process(f)
    File.open(f) { |file|
      arr =  file.readlines
      arr.each_with_index { |line, i|
        if line =~ /^> (.*)/ 
          if $1 == 'end log' then next end
          #line.gsub!(/"/, '\"')
          @testString << "     actual = @agent.send(\'#{$1}\')\n"
          begin
            @testString << "     expected = /#{arr[i+1].strip}/\n" 
          rescue
            @testString << "     expected = //\n" 
          end
          @testString << "     assert_match(expected, actual.to_s)\n\n"
        end
      }
    }
  end


end # class

if $0 == __FILE__
  D2t.new
end
