# Opens the link grammar executable as a subprocess, and handles submitting 
# input to and reading responses from the link process.

$DEBUG = false

class Link

   def initialize

      # HARDCODE WARNING - the name of the executable changes
      if RUBY_PLATFORM =~ /win/i or RUBY_PLATFORM =~ /ming/
        @lg = IO.popen("link41b.exe", "w+") # windows
      end
      if RUBY_PLATFORM =~ /linux/i
        @lg = IO.popen("./parse", "w+") # linux
      end

      s = @lg.gets
      while s !~ /.*4.0.affix/ 
         p s
         s = @lg.gets
      end
      p s
      @lg.puts("!constituents=2")
      s = @lg.gets
      p s

      @rules = Array.new
      load_rules
   end

   def load_rules
      #@rules.push("if parse =~ /\\[VP suffering VP\\]/ then parse.sub!(/\\[VP suffering VP\\]/, '[NP suffering NP]') end")
      #@rules.push("if parse =~ /fruit.*flies.*like (\[NP .* NP\])/i then parse = \"[S [NP Fruit flies NP] [VP like #{$1} VP] S]\" end")
      #@rules.push("if parse =~ /time.*flies.*like.*\[NP (.*) NP\]/i then parse = \"[S [NP Time NP] [VP flies [NP like #{$1} NP] VP] S]\" end")
   end

   def getResponse(input="")
      p 'INPUT==' + input
      # check for words that are too long
      if input =~ /(\w){20,20}/
        puts "There is a word that is too long."
        return "There is a word that is too long."
      end
      if input.size > 300
        return "The input exceeded maximum length."
      end
      if input == "\"\""
         return "Sorry I didn't get that..."
      end
      begin
         return puts(input.to_s) # overloaded puts!
      rescue => error 
         return "Sorry I get an error when parsing that sentence: " + error
      end
   end

   # apply substitution rules to a Link Grammar flat constituent string
   def apply_rules(parse)
     @rules.each { |rule|
       puts "\nrule=#{rule}; parse=#{parse}\n"
       begin
         eval(rule) 
       rescue => e; p "Can't apply rule: #{e}"; end
     }
     return parse
   end

   def show_rules
     return @rules.join("\n")
   end

   def add_rule(rule = '')
     if rule == '' then return "There is no rule!" end
     if rule =~ /if parse =~.*then.*end/ 
       @rules.push(rule)
       return "Okay I have added #{rule}."
     end
     return "Rules should look like: if parse =~ /\\[S.*S\\]/ then parse.gsub!(/\\[S(.*)S\\]/, \"\#{$1}\") end"
   end

   def delete_rule(i = 0)
     if i < 1 or i > @rules.size
       return "The rules go from 1 to #{@rules.size}."
     end
     rule = @rules[i-1]
     @rules.delete_at(i-1)
     return "Okay, \"#{rule}\" deleted." 
   end

   # Get the first NP in questions of the form: is NP1 NP2?
   def getNP1(input = "")
      p "[link.getNP1]: input==" << input << "." unless not $DEBUG
      if input =~ /^\[.*\]$/
        parse = input
      else
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      p "[link.getNP1]: parse==" << parse << "." unless not $DEBUG
      #if parse =~ /\[NP (.*) NP\]( not | )\[(NP|ADJP)/
      if parse =~ /\[NP (.*) NP\] \[(NP|ADJP)/
      #if parse =~ /\[NP (.*) NP\] \[(NP|ADJP|VP)?/
         return process($1)
      end
      return "I don't know what the subject in " + input.to_s + " is." 
   end

   # Get the subject, which should be the first NP.
   def getSubject(input="")
      p "[link.getSubject]: input==" << input.to_s unless not $DEBUG
      if input =~ /^\[.*\]$/
        parse = input
      else
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      p "[link.getSubject]: parse==" << parse.to_s unless not $DEBUG
      if parse =~ /\[NP (.*?) NP\] \[(NP|ADJP|VP)?/
         return process($1.to_s)
      end
      return "I'm not sure what the subject in " + input.to_s + " is."
   end

   # Get the second NP in questions of the form: is NP1 NP2?.
   def getNP2(input = "")
      if input =~ /^\[.*\]$/
        parse = input
      else
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      p "[link.getNP2]: parse==" << parse << "." unless not $DEBUG
      #if parse =~ /\[NP .* NP\] (not |)\[(?:NP|ADJP) (.*) (?:NP|ADJP)\]/
      if parse =~ /\[NP .* NP\] \[(?:NP|ADJP) (.*) (?:NP|ADJP)\]/
      #if parse =~ /\[NP .* NP\].*\[VP.*\[(?:NP|ADJP) (.*) (?:NP|ADJP)\].*VP\]/
         if $2 == nil
            g2 = ""
         end
         r = $1.to_s << g2
         r = process(r)
         return r
      end
      return '' 
   end

   # Try to get the object of a declarative sentence.
   def getObject(input = "")
      if input =~ /^\[.*\]$/
        parse = input
      else  
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      if parse =~ /\[NP .* NP\] \[VP.*\[NP (.*) NP\].*VP\]/
         r = $1.to_s
         r = process(r)
         p "[link.getObject] returning: " + r unless not $DEBUG
         return r
      end
      return "I can't find the object in " + input.to_s
   end

   
   # Try to get the main verb of the sentence.
   # TODO: fix problems with conjunctions and adverbial phrases...
   def getV1(input = "")
      if input =~ /^\[.*\]$/
        parse = input
      else 
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      p "[link.getV1]: parse==" << parse << "." unless not $DEBUG
      if parse =~ /\[NP .* NP\] \[VP ([^(?:\[(?:NP|ADJP|PP)?)]) \[(?:(PP|NP|ADJP)?) VP\] \. S\]/
         p "[Link.getV1]: first match."
         r = $1.to_s
         r = process(r)
         p "[link.getV1] returning: " << r.to_s unless not $DEBUG
         return r.to_s
      end
      # Not working, need to get verbs separated by conjunctions and such.
      if parse =~ /\[NP .* NP\](?:[^\[VP])*\[VP (.*) (?:.*\[(?:(PP|NP|ADJP)?))/
         p "[Link.getV1]: second match."
         r = $1.to_s
         r = process(r)
         p "[link.getV1] returning: " << r.to_s unless not $DEBUG
         return r.to_s
      end
      if parse =~ /\[NP .* NP\] \[VP (.*) VP\]/
         p '[Link.getV1]: third match.'
         r = $1.to_s
         r = process(r)
         p "[link.getV1] returning: " << r.to_s unless not $DEBUG
         return r.to_s
      end

      return "I don't know what the verb is in " + input.to_s
   end

   def getSVO input
      subj = getSubject(input)
      if subj =~ /I can't/
         subj = ''
      end
      verb = getV1(input) 
      if verb =~ /I can't/
         verb = ''
      end
      obj = getObject(input)
      if obj =~ /I can't/
         obj = ''
      end
      r = subj + "; " + verb + "; " + obj
      p '[Link.getSVO]: returning==' + r
      return r
   end
 
   # Strip r of constituent tags.
   def process(r)
         r.gsub!(/\[WHNP /, "")
         r.gsub!(/\[NP /, "")
         r.gsub!(/\[NP/, "")
         r.gsub!(/\[PP /, "")
         r.gsub!(/\[SBAR /, "")
         r.gsub!(/\[ADVP /, "")
         r.gsub!(/\[VP /, "")
         r.gsub!(/\[S /, "")
         r.gsub!(/\[ADJP( )?/, "")
         r.gsub!(/\[PRT\s?/, "")
         r.gsub!(/WHNP\]( ){0,1}/, "")
         r.gsub!(/NP\]( ){0,1}/, "")
         r.gsub!(/PP\]( ){0,1}/, "")
         r.gsub!(/SBAR\]( ){0,1}/, "")
         r.gsub!(/ADVP\]( ){0,1}/, "")
         r.gsub!(/VP\]( ){0,1}/, "")
         r.gsub!(/S\]( ){0,1}/, "")
         r.gsub!(/ADJP\]( ){0,1}/, "")
         r.gsub!(/PRT\]\s?/, "")
         r.gsub!(/\.\s*$/, "")
         r.gsub!(/\[S/, "")
         r.strip!
         #p "[link.process]: r==" << r << "."
         r
   end

   def gets
      line = @lg.gets
      #print "1. [link.gets]: line==" + line + "\n"
      @fullp = ""
      @fullp << line
      #p line
      if line =~ /^linkparser> \+\+\+\+Time/
         #print "2. [link.gets]: line==" + line + "\n"
         line = 'temp' 
         #print "3. [link.gets]: line==" + line + "\n"
         #line = @lg.gets.to_s
      end
      #while line !~ /^linkparser>/
      while line !~ /^Press RETURN/ or line !~ /^linkparser>/
         #p line
         line = @lg.gets.to_s
         @fullp << line 
         if @fullp =~ /^.*\n(\[S .*\]) \n$/
            print "[link.gets]: RETURNING: " + $1.to_s  + "\n"
            toReturn =  $1
            toReturn = apply_rules(toReturn)
            return toReturn
         end
      end
      return @fullp
   end

   def puts(s="")
      s.strip!
      p "PUTS S==" + s unless not $DEBUG 
      if s == "\"\"" or s == "\"" or s == "''" or s == ""
         return "Sorry the input is blank."
      end
      if s =~ /^!/ then return "I can't set link grammar directives." end
      if s =~ /(\w{60,})/ then return "#{1} is too long." end
      if s.size > 300 then return "The input is too long." end
      @lg.puts(s.to_s)
      gets
   end

   # Get a more abstract linguistic representation of the parse
   # "John ate an apple" -> "(NP (VP NP))"
   def get_simple_parse(input)
      p "[get_simple_parse] input==#{input}" unless not $DEBUG
      if input =~ /^\[.*\]$/ 
        parse = input
      else
        parse = puts(input) # overloaded puts
        parse = apply_rules(parse)
      end
      sp = Array.new 
      sp.push("(")
      parse.split(' ').each { |token|
         p 'TOKEN==' + token
         case token 
            when /\[S/
               next
            when /S\]/
               next
            when /\[([A-Z]+)/
               sp.push "(#{$1} "
            when /([A-Z]+)\]/
               sp.push ")"
         end
      }
      sp.push ")"
      r = sp.join.to_s
      p 'RETURNING' + r.to_s
      r.strip!
      while r =~ /\(([A-Z]+)(?: )?\)/
         r.sub!(/\(([A-Z]+)(?: )?\)/, "#{$1} ")
      end
      while r =~ /\)([A-Z]+)/ 
         r.sub!(/\)([A-Z]+)/, ") #{$1}")
      end
      while r =~ /([A-Z]+) (\1)/
         r.sub!(/([A-Z]+) (\1)/, "#{$1}")
      end

      r.gsub!(/ \)/, ")")
      p 'RETURNING' + r.to_s
      return r 
   end


end # class Link

if $0 == __FILE__
  link = Link.new
  print ("\n> "); $stdout.flush
  quitwords = [":q", "quit", "exit", "bye"]
  while (line = gets) !~ /^#{quitwords.join('|')}$/i and line !~ /^$/
    print link.getResponse(line) + "\n"
    print ("\n> "); $stdout.flush
  end
  print "Bye!"
end
