require 'test/unit'
require 'linkbot'

class TestLinkbot < Test::Unit::TestCase
  
  def setup
    @link = MyAgent.new
  end

  def test1
    actual = @link.send("subject: John ate an apple")
    assert_match(/^John/, actual)

    actual = @link.send("verb: John ate an apple")
    assert_match(/^ate/, actual)

    actual = @link.send("object: John ate an apple.")
    assert_match(/^an apple/, actual)

    actual = @link.send("slkdfjsldkfjsldkfjsldkfjsldfkjsdlfkjsdffsdfsdfsdfsdfsdfsdfsdfsdfsdf")
    assert_match(/too long/, actual)

    actual = @link.send("subject: this is a very long input sentence that will crash l grammar so we have to make sure that the ruby wrapper traps a long input such as this one before it gets to the l grammar code that will crash on it or require too much time to figure it out....not enough characters yet to make up 300 characters which is the hardcoded limit i've set in the code ok this should do it...wait i have to make it 300 characters AFTER THE WORD l because it thinks that any occurence of the word l in a sentence is an invocation of its name and it will only submit everything after that occurence to the bot as its input!")
    assert_match(/too long/, actual)

    actual = @link.send("subject: John ate an apple")
    assert_match(/^John/, actual)

    actual = @link.send("verb: John ate an apple")
    assert_match(/^ate/, actual)
   
    actual = @link.send("parse into constituents \"John ate an apple\"")
    assert_match(Regexp.new(Regexp.escape("[NP John NP] [VP ate [NP an apple")), actual)

    actual = @link.send("get simple parse: 'John ate an apple.'")
    assert_match(Regexp.new(Regexp.escape("(NP (VP NP))")), actual)

    actual = @link.send("svo: [S [NP You NP] [VP dwell [NP on suffering NP] VP] S]")
    assert_match(/.*=you.*=dwell.*=on suffering/i, actual)
  end

  def test_help
    actual = @link.send("help")
    assert_match(/link grammar/, actual)

    actual = @link.send("link: help")
    assert_match(/link grammar/, actual)
  end

  def test_rules
    actual = @link.send("show api")
    assert_match(/add pattern/, actual)

    actual = @link.send("show rules")
    assert_match(/(\bif\b|rules)/, actual)
  end

end
