require 'drb'

class LinkAgent 

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @link = DRbObject.new(nil, 'druby://localhost:9050')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^restart (.*)/ then return end
    if input =~ /^alice\b/ then return end
    if input =~ /^megahal\b/ then return end
    if input =~ /^calc\b/ then return end
    if input =~ /^porsi\b/ then return end
    if input =~ /^!sr\b/ then return end; if input =~ /^isr\b/ then return end
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^link/i then return end
    addtoscore = false
    if input =~ /^link[:, ]*/i then addtoscore = true end
    if input =~ /^link[:, ]*(.*)/ then input = $1.strip end 
    response = @link.getResponse(input)
    if response == nil then response = "Default response" end
    begin
      score = response.score 
    rescue 
      score = 1 
      if response.to_s =~ /Default response/ then score = 0 end
      if input =~ /(?:subject|object|verb)/ then score += 3 end
      if response.to_s =~ /\[S.*S\]/ then score += 3 end
    end
    if addtoscore then score += 4 end
    puts "Link: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "linkagent"])
  end

end
