require 'drb'

class LogicAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @logicagent = DRbObject.new(nil, 'druby://localhost:9012') 
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^(?:emoagent|emobot)/ then return end
    if input =~ /^(?:ifagent|ifbot)/ then return end
    if input =~ /^(?:gagent|gagentbot)/ then return end
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^logic/i then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^porsi\b/i then return end
    response, score = @logicagent.getResponse(input)
    if score == nil then score = 1 end
    if response =~ /Default response/ then score = 0 end
    if response =~ /because/ then score += 1 end
    if response =~ /Yes/ then score += 1 end
    if response =~ /Okay/ then score -= 2 end
    if response =~ /I don't know/i then score -= 2 end
    if response =~ /I have nothing/i then score -= 2 end
    #if response =~ /I have no knowledge/ then score -= 1 end
    if input =~ /(?:logicagent|logicbot|logicagentbot|logic agent|logagent|logbot)/i
      score += 3
    end
    if response == nil or response.strip == '' then score -= 2 end
    puts "LogicAgent: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "logicagent"])
  end
end
