# Controlbot that pushes responses when user doesn't enter input for a while.

require 'controlbot'
require 'readline'


if RUBY_PLATFORM =~ /win32/
  require 'Win32API'
  $win32_console_kbhit = Win32API.new("msvcrt", "_kbhit", [], 'I')
  def console_input_ready?
    $win32_console_kbhit.call != 0
  end
  def nonblocking_stdin_gets
    sleep(0.1) until console_input_ready?
    $stdin.gets  # getc also blocks until user hits <return>
  end
else
  def nonblocking_stdin_gets
    $stdin.gets   # it just works, on unix
  end
end

b = ControlBot.new
quitwords = [':q', 'quit', 'exit', 'bye', 'logout', 'logoff']
got_s = false
print "\n> "
a = Thread.new { loop {
  sleep(60) 
  if got_s
    puts "\n#{b.getResponse("...")}\n" 
    print "\n> "
  end
  }
}
while (line = nonblocking_stdin_gets) !~ /^(#{quitwords.join('|')})$/
  got_s = false
  puts b.getResponse(line); got_s = true
  print "\n> "
end
puts 'Bye!'
if RUBY_PLATFORM =~ /win/i then exec("exit/rubykill.exe") end # Windows
if RUBY_PLATFORM =~ /linux/i then exec("sh exit/rubykill.sh") end # Linux

