require 'test/unit'
require 'sumagent'
require 'FileUtils'

class TestMyAgent < Test::Unit::TestCase

  def setup
    if File.exist?('sumagent.rb')
      FileUtils.copy('sumagent.rb', 'sumagent.rb.save')
      begin 
        FileUtils.copy('sumagent-api.yaml', 'sumagent-api.yaml.save') 
      rescue; end
    end
    @agent = MyAgent.new
  end 

  def test_defining_hello
    actual, s = @agent.send("add pattern /^hello/, hello")
    
    actual, s = @agent.send("hello")

    actual, s = @agent.send(">  def hello(pattern=nil, input=nil)")
    actual, s = @agent.send(">    if @count == nil; @count = 1; return 'I am ready for my first lesson.'; end")
    actual, s = @agent.send(">    return 'Hello again.'")
    actual, s = @agent.send(">  end # method_def")

    actual, s = @agent.send("hello")
    assert_match(/lesson/, actual)

    actual, s = @agent.send("hi is a synonym for hello")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("hi")
    assert_match(/again/, actual)
  end

  def test_summarize
    actual, s = @agent.send("summarize: this!")
    assert_match(/this!/, actual.to_s)
  end


  def teardown
    File.delete('sumagent.rb') unless !File.exist?('sumagent.rb.save')
    begin; File.delete('sumagent-api.yaml'); rescue; end
    if File.exist?('sumagent.rb.save')
      FileUtils.copy('sumagent.rb.save', 'sumagent.rb')
      begin; FileUtils.copy('sumagent-api.yaml.save', 'sumagent-api.yaml'); rescue; end
    end
    if File.exist?('sumagent.rb') then File.delete('sumagent.rb.save') end
    if File.exist?('sumagent-api.yaml.save') then File.delete('sumagent-api.yaml.save') end
  end

end
