require 'test/unit'
require 'testagent'
require 'fileutils'

class TestMyAgent < Test::Unit::TestCase

  def setup
    if File.exist?('testagent.rb')
      FileUtils.copy('testagent.rb', 'testagent.rb.save')
      begin 
        FileUtils.copy('testagent-api.yaml', 'testagent-api.yaml.save') 
      rescue; end
    end
    @agent = MyAgent.new
  end 

  def test_defining_hello
    actual, s = @agent.send("add pattern /^hello/, hello")
    
    actual, s = @agent.send("hello")

    actual, s = @agent.send(">  def hello(pattern=nil, input=nil)")
    actual, s = @agent.send(">    if @count == nil; @count = 1; return 'I am ready for my first lesson.'; end")
    actual, s = @agent.send(">    return 'Hello again.'")
    actual, s = @agent.send(">  end # method_def")

    actual, s = @agent.send("hello")
    assert_match(/lesson/, actual)

    actual, s = @agent.send("hi is a synonym for hello")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("hi")
    assert_match(/again/, actual)
  end

  def test_list_files
    actual, s = @agent.send("list tests please")
    assert_match(/testcontrolbot/, actual)
  end

  #def test_run_testisr
  #  actual, s = @agent.send("run testisr")
  #  assert_match(/tests,.*assertions,.*failures,.*errors/, actual)
  #end 

  def test_what_were_results
    actual, s = @agent.send("run testisr")
    assert_match(/tests,.*assertions,/, actual)
   
    actual, s = @agent.send("what were the results?")
    assert_match(/testisr\.rb/, actual)
  end

  def teardown
    File.delete('testagent.rb') unless !File.exist?('testagent.rb.save')
    begin; File.delete('testagent-api.yaml'); rescue; end
    if File.exist?('testagent.rb.save')
      FileUtils.copy('testagent.rb.save', 'testagent.rb')
      begin; FileUtils.copy('testagent-api.yaml.save', 'testagent-api.yaml'); rescue; end
    end
    if File.exist?('testagent.rb') then File.delete('testagent.rb.save') end
    if File.exist?('testagent-api.yaml.save') then File.delete('testagent-api.yaml.save') end
  end

end
