Dir.chdir("..")

require 'test/unit'
require 'controlbot'

class TestControlbotCommands < Test::Unit::TestCase

  def setup
    @agent = ControlBot.new
  end

  def test_delay
    print "testing delay... "
    name = @agent.send("what is your name?")
    orig_delay = @agent.send("#{name}: what is the delay?")
    puts "orig_delay: #{orig_delay}"
    if orig_delay =~ /The delay is (.*)/
      orig_delay = $1
    end
    #puts "orig_delay: #{orig_delay}"

    actual = @agent.send("#{name}: set the delay to 0.5")
    assert_match(/0\.5/, actual)

    actual = @agent.send("#{name}: set the delay to #{orig_delay}")
    puts actual
  end

  def test_sleep
    print "testing sleep... "
    name = @agent.send("what is your name?")
    orig_sleep = @agent.send("#{name}: what is the sleep?")
    puts "orig_sleep: #{orig_sleep}"
    if orig_sleep =~ /The sleep.*is set to (.*)/
      orig_sleep = $1
    end
    actual = @agent.send("#{name}: set sleep to 0.5")
    assert_match(/0\.5/, actual)

    actual = @agent.send("#{name}: set the sleep to #{orig_sleep}")
    puts actual
  end

  def test_add_to_feedback
    print "testing add_to_feedback..."
    actual = @agent.send("add \"you suck\" to negative feedback")
    assert_match(/Okay/, actual)

    actual = @agent.send("Add \"lol\" to positive feedback")
    assert_match(/Okay/, actual)

    actual = @agent.send("show positive feedback")
    assert_match(/lol/, actual)

    actual = @agent.send("show negative feedback")
    assert_match(/you suck/, actual)

    actual = @agent.send("delete \"you suck\" from negative feedback")
    assert_match(/Okay/, actual)

    actual = @agent.send("delete \"lol\" from positive feedback")
    assert_match(/Okay/, actual)

  end


  def teardown
  end
end
