Dir.chdir("..")

require 'test/unit'
require 'controlbot'

# Relevant agents must be started before running this test.
class TestControlbot < Test::Unit::TestCase

  def setup
    @agent = ControlBot.new
    name = @agent.send("what is your name?")
    @agent.send("#{name}: set delay to 5.0")
    @agent.send("#{name}: set sleep to 4.0")
  end

  def test_monty
    sleep(5)
    actual = @agent.send('monty: help')
    assert_match(/montylingua/i, actual)

    sleep(5)
    actual = @agent.send('monty: subject: John ate an apple.')
    assert_match(/John/, actual)

    sleep(5)
    actual = @agent.send('monty: what is the object in John ate an apple.')
    assert_match(/an apple/, actual)
  end

end
