Dir.chdir("..")

require 'test/unit'
require 'controlbot'

# Tests the liar's paradox (see subbot.org/essays/liar).
# gagentbotd, emobotd, and oppbotd  must be started before running this test.

class TestControlbot < Test::Unit::TestCase

  def setup
    @agent = ControlBot.new
    name = @agent.send("what is your name?")
    #@agent.send("#{name}: set delay to 5.0")
    #@agent.send("#{name}: set sleep to 4.0")
  end

  def test_liar
    @agent.send("logicagent: reset graph")
    @agent.send("ifagent: reset graph")

     actual = @agent.send('a = "a = false"')
     expected = /Okay, a = a = false./
     #assert_match(expected, actual.to_s)

     actual = @agent.send('Assume a = true                ')
     expected = /Okay, I will assume a = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if a = true, then "a = false" = true')
     expected = /Okay, a = true -> a = false = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('does "a = false" = true?')
     expected = /Yes, a = false = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if "a = false" = true, then a = false')
     expected = /Okay, a = false = true -> a = false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('But "a = false" is a contradiction of our assumption that a = true!')
     expected = /Therefore, a != true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if a != true, then a = false')
     expected = /Okay, a != true -> a = false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('forget that a = true')
     expected = /Okay I have deleted a = true./
     #assert_match(expected, actual.to_s)

     actual = @agent.send('assume a = false')
     expected = /Okay, I will assume a = false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if a = false, then "a = false" = false')
     expected = /Okay, a = false -> a = false = false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('does "a = false" = false?')
     expected = /Yes, a = false = false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if "a = false" = false, then a = true')
     expected = /Okay, a = false = false -> a = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('does a = true?')
     expected = /Yes, a = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('but "a = true" is a contradiction of our assumption that a = false!')
     expected = /Therefore, a != false./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if a != false, then a = true')
     expected = /Okay, a != false -> a = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('does a = true? ')
     expected = /Yes, a = true./
     assert_match(expected, actual.to_s)

     actual = @agent.send('does a = false?')
     expected = /Yes, a = false./
     assert_match(expected, actual.to_s)
  end

  def tear_down
    @agent.send("logicagent: reset graph")
    @agent.send("ifbot: reset graph")
  end
end
