Dir.chdir("..")

require 'test/unit'
require 'controlbot'

class TestFile < Test::Unit::TestCase

  def setup
     @agent = ControlBot.new
     @agent.send("logicagent: reset graph")
     @agent.send("ifbot: reset graph")
     actual, s = @agent.send("calcbot: stfu")
     assert_match(/threshhold/, actual)
  end

  def test_ordinal_contradiction
     actual = @agent.send('Assume N is the greatest ordinal.')
     expected = /Okay, I will assume N is the greatest ordinal./
     assert_match(expected, actual.to_s)

     actual = @agent.send('if N is the greatest ordinal, then the number of ordinals from 0 to N is N + 1.')
     expected = /Okay, N is the greatest ordinal -> the number of ordinals from 0 to N is N \+ 1\./
     assert_match(expected, actual.to_s)

     actual = @agent.send('logicagent: N + 1 is an ordinal')
     expected = /Okay, N \+ 1 is an ordinal\./
     #assert_match(expected, actual.to_s)

     actual = @agent.send('if N + 1 is an ordinal, then N is greater than N + 1')
     expected = /Okay, N \+ 1 is an ordinal -> N is greater than N \+ 1\./
     assert_match(expected, actual.to_s)

     actual = @agent.send('but "N is greater than N + 1" is absurd! Because of the definitions of addition and 1')
     s1 = "Therefore, It is not the case that N is the greatest ordinal."
     s2 = "Therefore, N is not the greatest ordinal."
     expected = Regexp.new("#{s1}|#{s2}")
     assert_match(expected, actual.to_s)

  end

  def teardown
     @agent.send("logicagent: reset graph")
     @agent.send("ifbot: reset graph")
     @agent.send("calcbot: loud")
  end

end #class
