require 'drb'

class TestAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @testbot = DRbObject.new(nil, 'druby://localhost:9140')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+agent/ and input !~ /^testagent/i then return end
    response, score  = @testbot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^test(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    if response =~ /.*tests,.*assertions,.*failures,.*errors/ then score += 3 end
    if response =~ /^test.*/ then score += 3 end
    puts "TestBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "testagent"])
  end
end
