module PreRulesMod

     def getResponse(input)

      input = input.to_s
      #print 'INPUT==' + input + "\n"

      # Set threshhold.
      if input =~ /^what is your name?/i
         name = @MY_NAME.gsub(/\(\?i\)\(\?\:/, '')
         name.gsub!(/\|/, ' or ')
         name.gsub!(/\)/, '')
         return name.to_s
      end

      if input =~ /^#{@MY_NAME}[:,!]* (quiet|be quiet|stfu|shut.*up)/
         @THRESHHOLD = @THRESHHOLD + 1
         @SCORE_MOD -= 1
         return "My threshhold is now " << @THRESHHOLD.to_s << ", and my score_mod is #{@SCORE_MOD}."
      end
      if input =~ /^#{@MY_NAME}[:,!]* (speak.*up|loud|louder|i can't hear you)/
         @THRESHHOLD = @THRESHHOLD - 1
         @SCORE_MOD += 1
         return "My threshhold is now " << @THRESHHOLD.to_s << ", and my score_mod is #{@SCORE_MOD}."
      end
      # Return threshhold
      if input =~ /^#{@MY_NAME}[:,!]* what is your (threshhold|threshold|volume)/ or input =~ /^#{@MY_NAME}[:,!]* (?:threshold|threshhold|volume)/
         return "My threshhold is currently " << @THRESHHOLD.to_s
      end

      # Provide help message.
      if input =~ /^#{@MY_NAME}[:,!]* help/
         return "I look up terms in Wolfram Alpha. Usage: .wa Wolfram"
      end

      # trap restart
      case input
        when /^#{@MY_NAME}[:,!]* restart/, /^restart/
          #return "That command is disabled." # for safety
          exec("ruby #{__FILE__}")
      end

      # add new if-then rules to post-process responses
      case input
        when /^#{@MY_NAME}[:,!]* (if .*? =~ .*? then .*)$/
          return add_if_rule($1)
      end

      # show the rules
      case input
        when /^#{@MY_NAME}[:,!]*.* show.* rules/
          return show_rules[0]
      end

      # delete all rules
      case input
        when /^#{@MY_NAME}[:,!]*.* delete.* rules/
          return delete_rules
      end

      # delete a rule
      case input
        when /^#{@MY_NAME}[:,!]*.* delete.* rule.* (\d+)/
          return delete_rule($1.to_i)
      end

      # set safe level
      case input
        when /^#{@MY_NAME}[:,! ]*(?:set )?.*safe(?:ty)? level (?:to )?(.*)/
          return set_safe_level($1)
      end

      # get safe level
      case input 
        when /^#{@MY_NAME}[:,! ]*what is.*?safe(?:ty)? level/
          return  get_safe_level
      end

      # Set DEBUG level
      case input
        when /^#{@MY_NAME}[:,!]*.*on ?(?:the )?debug(?: mode)?/i,
             /^#{@MY_NAME}[:,!]*.*debug(?: mode)? on/i
          @DEBUG = 1; @agent.DEBUG = 1; return "I have turned on debug output."
        when /^#{@MY_NAME}[:,!]*.*off ?(?:the )?debug(?: mode)?/i,
             /^#{@MY_NAME}[:,!]*.*\bdebug\b.*\boff\b/i
          @DEBUG = 0; @agent.DEBUG = 0; return "I have turned debug output off."
        when /^what is the debug mode/i, 
             /^#{@MY_NAME}[:,!]*.*what is (?:the )?debug(?: mode|setting|level)?/
          setting = "on"
          if @DEBUG == 0 then setting = "off" end
          return "The debug mode is currently #{setting}."
      end

      # Get the agent's response.
      if input =~ /^#{@MY_NAME}[:,! ]*(.*)/ then input = $1.strip end
      puts "input==#{input}" unless @DEBUG == 0
      input = apply_preprocessing_if_rules(input)
      puts "input after preprocessing rules: #{input}" unless @DEBUG == 0
      r, s = @agent.getResponse(input)
      if s == nil then s = 1 end
      r, s = apply_if_rules(r,s,input)
      s += @SCORE_MOD
      if r.to_s.size > @MAX_RESPONSE
         r = r[0..@MAX_RESPONSE]
      end
      puts "\n[WaBot] score==#{s}; threshhold==#{@THRESHHOLD}" unless @DEBUG == 0
      puts "r == #{r}" unless @DEBUG == 0
      if s > @THRESHHOLD 
        if $0 == __FILE__ then return r end
        puts "[WaBot] r==#{r}; s==#{s}" unless @DEBUG == 0
        return [r, s]
      else
         #puts 'r==' + r
      end

      return ""
   end

   def apply_preprocessing_if_rules(input)
     @rules.each { |rule|
       if rule =~ /input.gsub\!\(/
         if @DEBUG > 0
           puts "[apply_preprocessing_if_rule] rule==#{rule}"
         end
         begin
           eval(rule)
         rescue Exception => e 
           puts "Can't apply rule: #{rule}" unless @DEBUG == 0
           next 
         end
       end
     }
     return input
   end

end
