# Opens the wordnet executable as a subprocess, and handles submitting 
# input and reading responses from the wordnet process.

trap('INT') { exit }
trap('TERM') { exit }

class Wordnet 

   def initialize
      puts "Wordnet.rb started."
   end

   def getResponse(input = "")
      time = Time.now.strftime("%a %m/%d %H:%M")
      puts "\n[#{time}] RECEIVED: " + input.to_s
      return submitRawInput(input) unless input !~ /^wn /
      r = ""
      command = "wn"
      @wordnet = IO.popen("wn " << input << " -over") { |f|
         temp = f.readlines
         temp.delete("\n")
         temp.each { |elem| 
            p elem 
            if elem.strip == "\n"
               temp.delete(elem)
            end
            if elem =~ /^\d/
               elem.chomp!
               r << " " << process(elem)
            end
         }
      }
      p "[Wordnet.getResponse]: returning: " << r << "."
      return r 
   end

   # Make the definition more human-like.
   def process(elem)
      r = elem
      return r
   end

   def submitRawInput(input="")
      r = ""
      begin
        @wordnet = IO.popen(input) { |f|
            temp = f.readlines
            temp.delete("\n")
            count = 0
            temp.each { |elem| 
              elem = elem.to_s
              elem.strip!
              p elem 
              count += 1
              if count == 1
                 #temp.delete(elem)
                 #next
              end
              if elem == "\n"
                #temp.delete(elem)
                next
              end
              if elem =~ /^Synonyms/
                 #temp.delete(elem)
                 next
              end
              if elem =~ /^Sense \d+/
                 #temp.delete(elem)
                 next
              end
              if elem =~ /^Similarity of/
                 #temp.delete(elem)
                 next
              end
              if elem =~ /^=> (.*)/
                 elem = $1.to_s
              end
              if elem =~ /No information available/ then next end
              if elem =~ /Information available/ then next end
              if elem =~ /^Overview of/ then next end
              if elem =~ /from tagged texts/ then next end
              if r == ''
                r << elem << ", "
              else 
                r << " " << elem << ", "
              end
            }
        }
      rescue => error
         return "Problem submitting to Wordnet: " + error
      end
      r.strip!
      if r =~ /,$/
         r.chop!
      end
      p "[Wordnet.submitRawInput]: returning: " << r << "."
      return r 
   end

end # class
